/**
 * Copyright bradsedito ( http://wonderfl.net/user/bradsedito )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/oojh
 */







    import flash.display.*;
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.geom.ColorTransform;
    import flash.net.URLRequest;
    import flash.system.LoaderContext;
    import idv.cjcat.stardust.common.clocks.SteadyClock;
    import idv.cjcat.stardust.threeD.renderers.DisplayObjectRenderer3D;
    import jp.progression.commands.lists.SerialList;
    import jp.progression.commands.net.LoadBitmapData;
    
    [SWF(width="465", height="465", frameRate="60")]
    public class Main extends Sprite {
        public static var petelBmd:BitmapData;
        private static const CONTEXT:LoaderContext = new LoaderContext(true);
        
        public function Main() {
            addChild(_container);
            addChild(new Bitmap(_bmd));
            stage.quality = StageQuality.LOW;
            _emitter = new SakuraEmitter(new SteadyClock(1));
            _renderer = new DisplayObjectRenderer3D(_container);
            _renderer.addEmitter(_emitter);
            _renderer.camera.position.x = 500;
            _renderer.camera.position.y = -200;
            _renderer.camera.position.z = -500;
            _renderer.camera.direction.set(-500, 0, 0);
            new SerialList(null, new LoadBitmapData(new URLRequest("http://assets.wonderfl.net/images/related_images/3/33/331b/331bb452e206976414f4577fb6709f48ac822ef3"), { context: CONTEXT }), function():void {
                    addChildAt(new Bitmap(this.latestData as BitmapData), 0);
                }, new LoadBitmapData(new URLRequest("http://assets.wonderfl.net/images/related_images/b/bd/bdae/bdaee24a0702bb49aeef880cbdc56729d78dc22b"), { context: CONTEXT }), function():void {
                    petelBmd = this.latestData as BitmapData;
                    addEventListener(Event.ENTER_FRAME, _onEnterFrame);
                    stage.addEventListener(MouseEvent.MOUSE_DOWN, _onMouseDown);
                    stage.addEventListener(MouseEvent.MOUSE_UP, _onMouseUp);
                }).execute();
        }
        private var _bmd:BitmapData = new BitmapData(465, 465, true, 0x00000000);
        private var _container:Sprite = new Sprite();
        private var _emitter:SakuraEmitter;
        private var _renderer:DisplayObjectRenderer3D;
        
        private function _onEnterFrame(event:Event):void {
            _emitter.step();
            _bmd.colorTransform(_bmd.rect, new ColorTransform(1, 1, 1, 0.3));
            _bmd.draw(_container);
        }
        
        private function _onMouseDown(e:Event):void {
            _emitter.stepTimeInterval = 0.05;
            stage.quality = StageQuality.MEDIUM;
        }
        
        private function _onMouseUp(e:Event):void {
            _emitter.stepTimeInterval = 1;
            stage.quality = StageQuality.LOW;
        }
    }
}
import flash.display.*;
import idv.cjcat.stardust.common.actions.Age;
import idv.cjcat.stardust.common.actions.AlphaCurve;
import idv.cjcat.stardust.common.actions.DeathLife;
import idv.cjcat.stardust.common.clocks.Clock;
import idv.cjcat.stardust.common.emitters.Emitter;
import idv.cjcat.stardust.common.initializers.Life;
import idv.cjcat.stardust.common.initializers.Scale;
import idv.cjcat.stardust.common.math.UniformRandom;
import idv.cjcat.stardust.common.particles.Particle;
import idv.cjcat.stardust.threeD.actions.Move3D;
import idv.cjcat.stardust.threeD.actions.StardustSpriteUpdate3D;
import idv.cjcat.stardust.threeD.emitters.Emitter3D;
import idv.cjcat.stardust.threeD.initializers.DisplayObjectClass3D;
import idv.cjcat.stardust.threeD.initializers.Position3D;
import idv.cjcat.stardust.threeD.initializers.Velocity3D;
import idv.cjcat.stardust.threeD.zones.CubeZone;
import idv.cjcat.stardust.twoD.display.StardustSprite;

class SakuraEmitter extends Emitter3D {
    public function SakuraEmitter(clock:Clock) {
        super(clock);
        //initializers
        addInitializer(new DisplayObjectClass3D(SakuraPetalWrapper));
        addInitializer(new Life(new UniformRandom(100, 40)));
        addInitializer(new Position3D(new CubeZone(-200, -900, -200, 1600, 300, 1600)));
        addInitializer(new Velocity3D(new CubeZone(-30, 10, -30, 30, 10, 30)));
        addInitializer(new Scale(new UniformRandom(1, 0.3)));
        //actions
        addAction(new Age());
        addAction(new Move3D());
        addAction(new DeathLife());
        addAction(new StardustSpriteUpdate3D());
        addAction(new AlphaCurve(15, 15));
    }
}

class SakuraPetalWrapper extends StardustSprite {
    public function SakuraPetalWrapper() {
        phase = 0;
        petel = new Bitmap(Main.petelBmd);
        innerWrapper = new Sprite();
        innerWrapper.addChild(petel);
        petel.rotation = Math.random() * 360;
        rotation *= Math.random() * 360;
        selfOmega = Math.random() * 10;
        petalOmega = Math.random() * 10;
        scaleXRate = Math.random() * 0.03 + 0.07;
        addChild(innerWrapper);
    }
    private var innerWrapper:Sprite;
    private var petalOmega:Number;
    private var petel:Bitmap;
    private var phase:Number;
    private var scaleXRate:Number;
    private var selfOmega:Number;
    
    override public function update(emitter:Emitter, particle:Particle, time:Number):void {
        petel.rotation += petalOmega * time;
        rotation += selfOmega * time;
        phase += time;
        innerWrapper.scaleX = Math.sin(scaleXRate * phase);
    }






////////////////////////








// forked from thoton's 多言語ぐるぐる
// forked from thoton's forked from: 3D tag cloud
// forked from esabear's 3D tag cloud
package {
    import flash.display.Sprite;
    import flash.display.BitmapData;
    import flash.events.Event;
    import flash.text.TextField;
        import flash.text.TextFieldAutoSize;
    import flash.text.TextFormat;
    import flash.filters.GlowFilter;
    import flash.filters.BlurFilter;
    import flash.filters.BitmapFilterQuality;
    import org.papervision3d.view.BasicView;
    import org.papervision3d.objects.DisplayObject3D;
    import org.papervision3d.materials.special.BitmapParticleMaterial;
    import org.papervision3d.core.geom.Particles;
    import org.papervision3d.core.geom.renderables.Particle;
    import org.papervision3d.events.InteractiveScene3DEvent;

    public class FlashTest extends Sprite {
        private var scale:Number = 2;
        private var radius:Number = 500;
        private var smoothing:Boolean = true;
        private var minAlpha:Number = 0.1;
        private var glow:GlowFilter;
        private var tags:Array;
        private var tag_num:uint;
        private var bv:BasicView;
        private var tagArray:Array;
        private var tagContainer:DisplayObject3D;

        public function FlashTest() {
            // write as3 code here..
            init ();
        }
        
        private function init ():void {
            glow = new GlowFilter (0x003366, 1, 8, 8, 2, BitmapFilterQuality.LOW, true, false);
            // tags = ["三\n寒\n四\n温","ひ\nの\nな\nい\nと\nこ\nろ\nに\nけ\nむ\nり\nは\nた\nた\nな\nい","C","D","E","F","G","H","I","J","K","L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z",];
            // tags = ["A","B","C","D","E","F","G","H","I","J","K","L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z",];
            // tags = ["あ\nい\nう\nえ\nお","かきくけこ","さ\nし\nす\nせ\nそ","たちつてと","は\nひ\nふ\nへ\nほ","まみむめも","や\nゆ\nよ","らりるれろ","わ\nを\nん"];

//            tags = [
// "←", "accent","accented","accentless","accent mark","accentor","accentual","accentuate","accentuation","accept","acceptability","acceptable","acceptably","acceptance",
// "acceptant","acceptation","accepted","accepter","acceptor","access","accessary","accessibility",
// "accessible","accession","accessorial","accessorize","accessory","access provider","access time","acciaccatura",
// "accidence","accident","accidental","accidentally","accident and emergency",
// "accident insurance","accident-prone","accidie", "→"
// ];

            tags = ["photography.", "flash", "augmented reality [AR]", "design","actionscript 3.0", "interactivity", "after effects", "photography.", "flash", "augmented reality [AR]", "design","actionscript 3.0", "interactivity", "after effects", "photography.", "flash", "augmented reality [AR]", "design","actionscript 3.0", "interactivity", "after effects", "photography.", "flash", "augmented reality [AR]", "design","actionscript 3.0", "interactivity", "after effects"];
 
 //           tags = [
// "■\n亜\n鉛\n　\nあ\n‐\nえ\nん",
// "■\n亜\n鉛\n華\n　\nあ\nえ\nん\n‐\nか",
// "■\n亜\n鉛\n華\n軟\n膏\n　\nあ\nえ\nん\nか\n‐\nな\nん\nこ\nう",
// "■\n亜\n鉛\n鉄\n板\n　\nあ\nえ\nん\n‐\nて\nっ\nぱ\nん",
// "■\n亜\n鉛\n凸\n版\n　\nあ\nえ\nん\n‐\nと\nっ\nぱ\nん",
// "■\n亜\n鉛\n版\n　\nあ\nえ\nん\n‐\nば\nん",
// "■\n亜\n欧\n　\nあ\n‐\nお\nう",
// "■\n亜\n欧\n堂\n田\n善\n　\nあ\nお\nう\nど\nう\n‐\nで\nん\nぜ\nん",
// "■\n亜\n科　\nあ\n‐\nか"
//            ];
            
            tag_num = tags.length;
            tagArray = [];
            tagContainer = new DisplayObject3D ("tag_container");
            tagContainer.x = -radius * 0.25;
            tagContainer.y =  radius * 0.25;
            
            bv = new BasicView (stage.stageWidth, stage.stageHeight, true, true);
            bv.viewport.interactive = true;
            bv.scene.addChild (tagContainer);
            bv.camera.z = -1.5 * radius;
            bv.camera.zoom = 20;
            bv.startRendering ();
            
            addChild (bv);
            
            buildTags ();
            
            addEventListener (Event.ENTER_FRAME, enterFrameHandler);
        }
        
        private function buildTags ():void {
            var i:uint;
            for (i = 0; i < tag_num; i++) {
                // 2D
                var txt:TextField = new TextField ();

var Fmt:TextFormat;
Fmt = new TextFormat();
Fmt.font = "ヒラギノ明朝 Pro W6";

// embedFmt.font = "_ゴシック";
Fmt.size = 12;
Fmt.color = 0x000000;
txt.setTextFormat(Fmt);

                txt.antiAliasType = "advanced";
                txt.text = tags[i];
                            
                txt.filters = [new BlurFilter(1.1, 1.1)];
                // textformat.font = ;

                                                
                var txtW:Number = txt.textWidth + 4;
                var txtH:Number = txt.textHeight + 4;
                var bitmap:BitmapData = new BitmapData (txtW, txtH, true, 0x01FFFFFF);
                    bitmap.draw (txt);

                var phi:Number = Math.acos((2 * (i + 1) - 1) / tag_num - 1);
                var theta:Number = Math.sqrt(tag_num * Math.PI) * phi;

                // 3D
                var material:BitmapParticleMaterial = new BitmapParticleMaterial (bitmap);
                    material.interactive = true;
                    material.smooth = smoothing;
                var tag:Particle = new Particle (material, scale, 0, 0, 0);
                var tagHolder:Particles = new Particles ("tag_");
                    tagHolder.addParticle (tag);
                    tagHolder.x = radius * Math.cos (theta) * Math.sin (phi);
                    tagHolder.y = radius * Math.sin (theta) * Math.sin (phi);
                    tagHolder.z = radius * Math.cos (phi);
                    tagHolder.useOwnContainer = true;
                    tagHolder.autoCalcScreenCoords = true;
                    tagHolder.addEventListener (InteractiveScene3DEvent.OBJECT_OVER, objectOverHandler);
                    tagHolder.addEventListener (InteractiveScene3DEvent.OBJECT_OUT, objectOutHandler);
                    //tagHolder.addEventListener (InteractiveScene3DEvent.OBJECT_PRESS, objectPressHandler);

                tagContainer.addChild (tagHolder);
                tagArray.push (tagHolder);
            }
        }
        
        private function objectOverHandler (e:InteractiveScene3DEvent):void {
        bv.viewport.buttonMode = true;
            e.target.filters = [glow];
        }

        private function objectOutHandler (e:InteractiveScene3DEvent):void {
        bv.viewport.buttonMode = false;

            for (var j:uint = 0; j < tag_num; j++) {
                tagArray [j].filters = [];
            }
        }
        
        private function enterFrameHandler (e:Event):void {
            tagContainer.rotationX += (mouseY - stage.stageHeight * 0.5) * 0.01;
            tagContainer.rotationY += (mouseX - stage.stageWidth * 0.5) * 0.01;

            for (var j:uint = 0; j < tag_num; j++) {
                tagArray[j].alpha = minAlpha + (1 - minAlpha) * (1 - (tagArray[j].screen.z - radius) / (2 * radius));
            }
        }
    }
}